<?php

/**
 * 
 * @version $Id: initiate.php,v 2.4.1.1 2003/12/12 22:24:21 fredo Exp $
 * @copyright 2003 
 * This file is part of MAP feature for BB4 
 * 
 * This file is include from other files as to include parameters
 * First : globalmap.cfg to create Global Values
 * 
 * Second : from filemapcfg with the following inside:
 * 
 * BACKGROUND = filemap.png (default : the one defined in globalmap.cfg)
 * 
 * In order to limit bbgen creation part, not mandatory
 * services defined in host are prioritary
 * if none are defined (neither in SERVICES, neither in hosts), then full services
 * SERVICES = service1:serv2:... 
 * HOST = hostname:[parenthostlist_withoption]:x:y:picture[:serv1,serv2,... (limit of services, mandatory on SERVICES]
 * HOSTGROUP = hostgroupname:[parenthostlist_withoption]:x:y:picture:host1,host2,host3,...[:serv1,serv2,...]
 * SUBMAP = submapname:[parenthostlist_withoption]:x:y:picture
 * 
 * where hostname is one of the hostname in bb-hosts
 * where hostgroupname is whatever you want
 * where submapname is the filename of another map (map/name.map => name)
 * 		Be careful of no recursion (circular reference)!
 * where parenthost is % for no parent or a comma-list of hostnames or hostgroupnames with options (!-list as hostname!color!witdh!title)
 * where x and y are central coordinate in the map
 * where picture is one of (rectangle,square,diamond,triangle,circle) or a picture file name
 * where service is one of column headers in bb web page
 * 
 * VAR = name:value 
 * in order to override for one particular map some value (title for instance)
 * 
 * create GlobalService (list of accepted services)
 * and create GlobalHost (list of everything usefull after)
 * GlobalHost will be as follow after this file
 * GlobalHost['Name_of_host'] = 
 * [ (0):Name_of_host, (1):[[Name_of_parent_host1,color,size,text],[N2,...],...], (2):"HOST" or "HOSTGROUP" or "SUBMAP",
 *        (3):x, (4):y, (5):picture_namefile, (6):empty (HOST) or [ host1, host2, ...] (HOSTGROUP,SUBMAP) list of members,
 *        (7):[service1, service2, ...] (optional, SUBMAP = empty),
 *        (8):[(0):host(group) color (1-6), 
 *             (1):[serv1, serv2, ...] (HOST) or [host1, host2, ...] (HOSTGROUP,SUBMAP) in color 1,
 * 		  (2): same for color 2, ..., (6): same for color 6] ]
 *        (9):[shape(area), "coord" for area, picture in java scrip] ]
 */
// $DEBUG = 1;
function DEBUGPRINT( $texte )
{
  Global $DEBUG;
  if ( $DEBUG ) {
    $filename = "error_map_log.txt";
    $ff = fopen( $filename, 'a+' );
    if ( is_writable( $filename ) ) {
      // write the file
      if ( ! @fwrite( $ff, "Error Message: " . date( "d-m-Y G:i:s" ) . ":" . $texte . "\n" ) ) {
        // if we are unable to write for any reason
        echo ( "<br>Error Message: " . $texte . "<br>\n" );
      } 
    } else {
      // if the file does not exist or is not writable..
      echo ( "<br>Error Message: " . $texte . "<br>\n" );
    } 
    fclose( $ff );
  } 
} 
//error_reporting( E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING | E_ALL );
error_reporting(E_ERROR);
$GlobalParam = parse_ini_file( "globalmap.cfg" );
$val = extract( $GlobalParam );
if ( $val == 0 ) {
  die( "Error while reading file globalmap.cfg" );
} 
function VARset_global( &$var, $name )
{
  if ( ! empty( $var ) ) {
    return;
  } 
  if ( ! empty( $_GET[$name] ) ) {
    $var = trim( $_GET[$name] );
  } else if ( ! empty( $_POST[$name] ) ) {
    $var = trim( $_POST[$name] );
  } else {
    $var = "";
  } 
} 
if ( ! isset( $CurrentFileMap ) ) {
  $CurrentFileMap = $filemapcfg;
} 
// now load the map configuration
$GlobalHost = array();
$GlobalService = array();

function Add_GlobalServices( $arrayofservice )
{
  Global $GlobalService;
  $temp = array_merge( $GlobalService, $arrayofservice );
  $GlobalService = array_unique( $temp );
} 

function Read_File_Line( $filename )
{
  if ( ! file_exists( $filename ) ) {
    die( "Cannot open file $filename!" );
  } 
  $lines = file( $filename );
  $result = array();
  foreach ( $lines as $line ) {
    $line = trim( $line );
    if ( ( $line == "" ) || ( $line{0} == ";" ) || ( $line{0} == "#" ) ) {
      // comment or empty line
      continue;
    } 
    $result[] = $line;
  } 
  return $result;
} 

$lines = Read_File_Line( $bbmap."map/" . $CurrentFileMap );
foreach ( $lines as $line ) {
  $pos = strpos( $line, "=" );
  $property = trim( substr( $line, 0, $pos ) );
  $val = trim( substr( $line, $pos + 1 ) );
  if ( ( $property == "" ) || ( $val == "" ) ) {
    continue;
  } 
  switch ( $property ) {
  case 'BACKGROUND':
    $filemapbackground = $val;
  break;
  case 'SERVICES':
    Add_GlobalServices( explode( ",", $val ) );
    break;
  case 'VAR':
    list( $name, $value ) = explode( ":", $val );
    $$name = $value;
    break;
  case 'HOST':
  case 'HOSTGROUP':
    $hostprop = explode( ":", $val ); 
  // hostname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict:[listserv]
  // hostgroupname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict:listhost:[listserv]
  // list is name separate by , (no blank space)
    $host = array( $hostprop[0], $hostprop[1], $property,
		   $hostprop[2], $hostprop[3], $hostprop[4] ); 
  // hostname or hostgroupname, parent hostname list and other info, HOSTGROUP or HOST,
  // x, y, picture
    $temp = explode(",", $host[1]);
    $newparents = array();
    foreach ($temp as $parent) {
      $newparents[] = explode("!", $parent);
    }
    $host[1] = $newparents;
    if ( $property == "HOSTGROUP" ) {
      $host[6] = explode( ",", $hostprop[5] ); // list of hosts in group
      if ( ! isset( $hostprop[6] ) ) {
	$host[7] = ""; // empty service list
      } else {
	$host[7] = explode( ",", $hostprop[6] ); // list of service  
	// NO          Add_GlobalServices($host[7]);
      } 
    } else {
      $host[6] = ""; // empty group list
      if ( ! isset( $hostprop[5] ) ) {
	$host[7] = ""; // empty service list
      } else {
	$host[7] = explode( ",", $hostprop[5] ); // list of service  
	// NO          Add_GlobalServices($host[7]);
      } 
    } 
    $GlobalHost[$hostprop[0]] = $host;
    break;
  case 'SUBMAP': 
    // submapname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict
    $hostprop = explode( ":", $val );
    $host = array( $hostprop[0], $hostprop[1], $property,
		   $hostprop[2], $hostprop[3], $hostprop[4] );
    $temp = explode(",", $host[1]);
    $newparents = array();
    foreach ($temp as $parent) {
      $newparents[] = explode("!", $parent);
    }
    $host[1] = $newparents;
    $submapname = $hostprop[0];
    if ($userpasswd != "") {
      $access = $userpasswd."@";
    } else $access = "";
    $listmap = file( "https://" . $access . $_SERVER['SERVER_NAME'] . "/" . $bbwebmap . "/statussubmap.php?submap=$submapname" ); 
    // return [listhost, globalstatus, redhosts,...,greenhosts]
    if ( trim( $listmap[0] ) != "" ) {
      $host[6] = explode( ",", trim( $listmap[0] ) );
      $host[8] = array( trim( $listmap[1] ) );
      for ( $i = 2; $i <= 7 ; $i++ ) {
	if ( trim( $listmap[$i] ) != "" )
	  $host[8][$i-1] = explode( ",", trim( $listmap[$i] ) );
	else
	  $host[8][$i-1] = "";
      } 
    } else {
      $host[6] = array();
      $host[8] = array( 3, "", "", "", "", "", "" );
    } 
    $GlobalHost[$hostprop[0]] = $host;
    break;
  default:
  } // switch else do nothing
} // end foreach lines
// verify global services list
if ( count( $GlobalService ) == 0 ) {
  require( 'servlist.php' );
  $GlobalService = $GlobalServList;
} 
// reset finalwidth and finalheight
if ( ( $filemapbackground != "none" ) && ( $filemapbackground != "" ) ) {
  $imginfo = getimagesize( $bbmap . $filemapbackground );

  if ( $imginfo ) {
    $finalwidth = $imginfo[0];
    $finalheight = $imginfo[1];
  } 
} 
// Now create global values depending on the configuration file
$GenW = round ( $genericwidth / 2 );
$GenH = round ( $genericheight / 2 );
$PixelGap = $genericsize;

// set order priority for color management
// $aordercolor = explode(",", $ordercolor);
// $revordercolor = array_flip($aordercolor);
// print_r($revordercolor);
// print_r($aordercolor);
$GlobalStatus = 6; //green : default
// $GlobalStatus = $aordercolor[5];

function Get_Colors( $hostname, $services )
{
  Global $statusreturn;
  if ( strpos( $statusreturn, "fullstatusreturn.sh" ) != false ) {
    // hostname only : fullstatusreturn
    $result = trim( shell_exec( $statusreturn . " " . $hostname ) );
    if ( $result == "" ) {
      $output = array( 3 );
      $output[1] = $output[2] = $output[3] = $output[4] = $output[5] = $output[6] = "NaN";
      return $output;
    } 
    $output2 = explode( ":", $result );
    $output = array();
    $output[0] = 6;
    for ( $i = 1; $i <= 6 ; $i++ ) {
      if ( trim( $output2[$i] ) != "" ) {
        $servtemp = explode( " ", trim( $output2[$i] ) );
        $servtemp2 = array();
        foreach ( $servtemp as $serv ) {
          $name = trim( $serv );
          if ( $name != "" && in_array( $name, $services ) ) {
            $servtemp2[] = $name;
          } 
        } 
        if ( count( $servtemp2 ) > 0 ) {
          $output[$i] = $servtemp2;
          if ( $output[0] > $i )
            $output[0] = $i;
        } else
          $output[$i] = "";
      } else {
        $output[$i] = "";
      } 
    } 
    return $output;
  } else { // hostname services...
    $output = trim( shell_exec( $statusreturn . " " . $hostname . " " . implode( ":", $services ) ) );
    if ( trim( $output ) == "" ) {
      $output = array( 3 );
      $output[1] = $output[2] = $output[3] = $output[4] = $output[5] = $output[6] = "NaN";
      return $output; // no information ?
    } 
    $output2 = explode( ":", $output );
    for ( $i = 1; $i <= 6 ; $i++ ) {
      if ( trim( $output2[$i] ) == "" ) {
        $output2[$i] = "";
      } else
        $output2[$i] = explode( ",", $output2[$i] );
    } 
    return $output2;
  } 
} 
// compute colors
$listofservice = array();
foreach ( $GlobalHost as $host ) {
  // SHAPE
  $xo = $host[3];
  $yo = $host[4]; 
  // create the shape fields
  switch ( $host[5] ) {
    case 'rectangle':
      $usedshape = "rect";
      $x1 = $xo - $GenW - $PixelGap;
      $y1 = $yo - $GenH;
      $x2 = $xo + $GenW + $PixelGap;
      $y2 = $yo + $GenH;
      $usedcoord = $x1.",".$y1.",".$x2.",".$y2;
      $pictureofshape = "";
      break;
    case 'square':
      $usedshape = "rect";
      $x1 = $xo - $GenW;
      $y1 = $yo - $GenH;
      $x2 = $xo + $GenW;
      $y2 = $yo + $GenH;
      $usedcoord = $x1.",".$y1.",".$x2.",".$y2;
      $pictureofshape = "";
      break;
    case 'diamond':
      $usedshape = "poly";
      $x1 = $xo;
      $y1 = $yo - $GenH;
      $x2 = $xo + $GenW;
      $y2 = $yo;
      $x3 = $xo;
      $y3 = $yo + $GenH;
      $x4 = $xo - $GenW;
      $y4 = $yo;
      $usedcoord = $x1.",".$y1.",".$x2.",".$y2.",".$x3.",".$y3.",".$x4.",".$y4;
      $pictureofshape = "";
      break;
    case 'triangle':
      $usedshape = "poly";
      $x1 = $xo - $GenW;
      $y1 = $yo + $GenH;
      $x2 = $xo;
      $y2 = $yo - $GenH;
      $x3 = $xo + $GenW;
      $y3 = $yo + $GenH;
      $usedcoord = $x1.",".$y1.",".$x2.",".$y2.",".$x3.",".$y3;
      $pictureofshape = "";
      break;
    case 'circle':
      $usedshape = "circle";
      $usedcoord = $xo.",".$yo.",".$genericwidth;
      $pictureofshape = "";
      break;
    default:
      $usedshape = "rect";
      $pictureofshape = "<img src=$bbwebmap/$host[5]>";
      $imginfo = getimagesize( $bbmap . $host[5] );
      if ( ! $imginfo ) { // in case we put a square
        $x1 = $xo - $GenW;
        $y1 = $yo - $GenH;
        $x2 = $xo + $GenW;
        $y2 = $yo + $GenH;
      } else {
        $xs = $imginfo[0];
        $ys = $imginfo[1];
        $x1 = $xo - round( $xs / 2 ) - 2;
        $y1 = $yo - round( $ys / 2 ) - 1;
        $x2 = $x1 + $xs + 2;
        $y2 = $y1 + $ys + 1;
      } 
      $usedcoord = $x1.",".$y1.",".$x2.",".$y2;
  } // end of switch shape
  $host[9] = array( $usedshape, $usedcoord, $pictureofshape );
  if ( $host[2] == "HOST" ) {
    if ( ( ! is_array( $host[7] ) ) && ( count( $GlobalService ) == 0 ) ) {
      // no restriction
      $listofservice = array();
    } else if ( ! is_array( $host[7] ) ) { // global restriction
      $listofservice = $GlobalService;
    } else { // local restriction
      $listofservice = $host[7];
    } 

    $host[8] = Get_Colors( $host[0], $listofservice );
    if ( $GlobalStatus > $host[8][0] ) {
      $GlobalStatus = $host[8][0];
    } 
  } else if ( $host[2] == "HOSTGROUP" ) {
    $groupcolor = 6;
    $grouphost = array( $groupcolor );
    for ( $i = 1; $i <= 6 ; $i++ ) {
      $grouphost[$i] = array();
    } 
    if ( ( ! is_array( $host[7] ) ) && ( count( $GlobalService ) == 0 ) ) {
      // no restriction
      $listofservice = array();
    } else if ( ! is_array( $host[7] ) ) { // global restriction
      $listofservice = $GlobalService;
    } else { // local restriction
      $listofservice = $host[7];
    } 

    foreach ( $host[6] as $subhost ) {
      $localhost = Get_Colors( $subhost, $listofservice );
      if ( $groupcolor > $localhost[0] ) {
        $groupcolor = $localhost[0];
      } 
      $grouphost[$localhost[0]][] = $subhost;
    } 
    $grouphost[0] = $groupcolor;
    for ( $i = 1 ; $i <= 6 ; $i++ ) {
      if ( count( $grouphost[$i] ) == 0 ) {
        unset( $grouphost[$i] );
        $grouphost[$i] = "";
      } 
    } 
    $host[8] = $grouphost;
    if ( $GlobalStatus > $groupcolor ) {
      $GlobalStatus = $groupcolor;
    } 
  } // End HOSTGROUP
  else { // SUBMAP
    if ( $GlobalStatus > $host[8][0] ) {
      $GlobalStatus = $host[8][0];
    } 
  } 
  $GlobalHost[$host[0]] = $host;
} 

if ( $DEBUG ) {
  echo "Global END: $GlobalStatus <br>\n<PRE>";
  print_r( $GlobalHost );
  echo "</PRE><br>";
} 

?>
